# Task 3: Implementati problema producator-consumator folosind semafoare.

import sys
import time
import random
from threading import *


def producer(index, buf, buf_empty, buf_full):
   while 1:
        time.sleep(random.uniform(0,2))     # float in the [0,2] interval
        
        # produce
        item = random.randint(-1000, 1000)
        
        # put an item in the buffer if the buffer is not full
        buf_empty.acquire()
        
        buf.append(item)
        
        print "Producer {} put {}\n".format(index, item),
        
        # the buffer now contains an item that can be consumed
        buf_full.release()


def consumer(index, buf, buf_empty, buf_full):
   while 1:
        time.sleep(random.randrange(2))
        
        # block until an item is available in the buffer
        
        buf_full.acquire()
        
        item = buf.pop()
        
        print "Consumer {} got {}\n".format(index, item),
        
        # the buffer can now be filled with another element 
        buf_empty.release()

def usage(script_name):
    print "Usage:\t%s num_producers num_consumers dim_buffer" % script_name


if __name__ == "__main__":
    buf = []
    
    if len(sys.argv) != 4:
        usage(sys.argv[0])
        sys.exit(0)
    
    num_prod = int(sys.argv[1])
    num_cons = int(sys.argv[2])
    dim_buf = int(sys.argv[3])
    
    producers = []
    consumers = []
    
    # can be acquired while there is still place to put item(s)
    buf_empty = Semaphore(dim_buf)
    
    # can be acquired if there is at least an item in the buffer
    buf_full = Semaphore(0)
    
    random.seed(0)
    
    for i in range(num_prod):
        producers.append(Thread(target=producer, args=(i, buf, buf_empty, buf_full)))
        producers[-1].start()
    
    for i in range(num_cons):
        consumers.append(Thread(target=consumer, args=(i, buf, buf_empty, buf_full)))
        consumers[-1].start()
    
    print "Started producers and consumers, press Ctrl^\ to stop\n",
    
    for p in producers:
        p.join()
    for c in consumers:
        c.join()
